/**
 * command-exists
 * v1.2.8
 * https://github.com/mathisonian/command-exists
 *
 * The MIT License (MIT)
 *
 * Copyright (c) 2014 Matthew Conlen
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
 * associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
 * NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

var exec=require("child_process").exec,execSync=require("child_process").execSync,fs=require("fs"),path=require("path"),access=fs.access,accessSync=fs.accessSync,constants=fs.constants||fs,isUsingWindows="win32"==process.platform,fileNotExists=function(n,c){access(n,constants.F_OK,function(n){c(!n)})},fileNotExistsSync=function(n){try{return accessSync(n,constants.F_OK),!1}catch(n){return!0}},localExecutable=function(n,c){access(n,constants.F_OK|constants.X_OK,function(n){c(null,!n)})},localExecutableSync=function(n){try{return accessSync(n,constants.F_OK|constants.X_OK),!0}catch(n){return!1}},commandExistsUnix=function(n,c,e){fileNotExists(n,function(t){if(t)localExecutable(n,e);else exec("command -v "+c+" 2>/dev/null && { echo >&1 "+c+"; exit 0; }",function(n,c,t){e(null,!!c)})})},commandExistsWindows=function(n,c,e){if(/[\x00-\x1f<>:"\|\?\*]/.test(n))e(null,!1);else exec("where "+c,function(n){e(null,null===n)})},commandExistsUnixSync=function(n,c){if(fileNotExistsSync(n))try{return!!execSync("command -v "+c+" 2>/dev/null && { echo >&1 "+c+"; exit 0; }")}catch(n){return!1}return localExecutableSync(n)},commandExistsWindowsSync=function(n,c,e){if(/[\x00-\x1f<>:"\|\?\*]/.test(n))return!1;try{return!!execSync("where "+c,{stdio:[]})}catch(n){return!1}},cleanInput=function(n){return/[^A-Za-z0-9_\/:=-]/.test(n)&&(n=(n="'"+n.replace(/'/g,"'\\''")+"'").replace(/^(?:'')+/g,"").replace(/\\'''/g,"\\'")),n};isUsingWindows&&(cleanInput=function(n){return/[\\]/.test(n)?'"'+path.dirname(n)+'"'+":"+('"'+path.basename(n)+'"'):'"'+n+'"'}),module.exports=function n(c,e){var t=cleanInput(c);if(!e&&"undefined"!=typeof Promise)return new Promise(function(e,t){n(c,function(n,s){s?e(c):t(n)})});isUsingWindows?commandExistsWindows(c,t,e):commandExistsUnix(c,t,e)},module.exports.sync=function(n){var c=cleanInput(n);return isUsingWindows?commandExistsWindowsSync(n,c):commandExistsUnixSync(n,c)};
